<?php
require APPPATH.'/libraries/REST_Controller.php';
class users_api extends REST_Controller
{
	public function __construct()
	{
		parent::__construct();
		$this->load->model('users_model');
		$this->load->helper('Ultils');
	}

	function user_get() 
	{ 

		$this->load->model('users_model');
		$first=$this->get('first');
		$offset=$this->get('offset');
		$order=array('created_at'=>'DESC');
		$where=array();
		$like=array();
		$where['activated']=1;

		$fb_id=$this->get('fb_id');
		if($fb_id!=null){
			$where['fb_id']=$fb_id;
		}

		$id=$this->get('id');
		if($id!=null){
			$where['id']=$id;
		}
		
		$data=$this->users_model->get('*',$where,$like,$first,$offset,$order);
		if($data!=null){
			$this->response($data); 
		}else{
			$this->response(array('empty'=>'empty_data'));
		}

	} 

	function pwd_post(){
		$id=$this->post('id');
		if($id!=null){
			$new_pass=$this->post("new_pass");
			$old_pass=$this->post("old_pass");
			$data=$this->users_model->get_by_id($id);

			if($data[0]->pwd==""){
				$new_pass=encrypt_pwd($new_pass);
				$this->users_model->update(array('pwd'=>$new_pass), array('id'=>$id));
				$this->response(array('success'=>1));
			}

			if($data[0]->pwd== encrypt_pwd($old_pass)){
				$new_pass=encrypt_pwd($new_pass);
				$this->users_model->update(array('pwd'=>$new_pass), array('id'=>$id));
				$this->response(array('success'=>1));

			}else{
				$this->response(array('success'=>0));
			}
		}else{
			$this->response(array('success'=>0));
		}
	}

	function login_post(){
		$email=$this->post('email');
		$pwd=$this->post('pwd');
		if(is_numeric($email)){
			$email=ltrim($email,"0");
		}
		if($email!=null && $pwd!=null){
			$data=$this->users_model->get_by_email_and_pwd($email,encrypt_pwd($pwd));
			if($data!=null){
				$this->response(array('success'=>1,'data'=>$data[0]));
			}else{
				$data=$this->users_model->get_by_username_and_pwd($email,encrypt_pwd($pwd));
				if($data!=null){
					$this->response(array('success'=>1,'data'=>$data[0]));
				}else{
					$this->response(array('success'=>0));
				}
			}
		}else{
			$this->response(array('success'=>0));
		}
	}

	function update_post(){
		$id=$this->post('id');
		$full_name=$this->post('full_name');
		$address = $this->post('address');
		$phone=$this->post('phone');

		$user=$this->users_model->get_by_id($id);
		if($user!=null){
			$data=array(
				'full_name'=>$full_name,
				'address'=>$address,
				'phone'=>$phone
			);
			$this->users_model->update($data,array('id'=>$id));
			$obj = null;
			$obj = $this->users_model->get_by_id($id);
			$this->response(array('success'=>1,'data'=>$obj[0]));
		}else{
			$this->response(array('success'=>0));
		}
	}

    //reponse code
    //0 : dont exist user
	function facebook_user_check_get() 
	{ 
		$fb_id=$this->input->get('fb_id');
		$data=$this->users_model->get_by_fb_id($fb_id);
		if($data==null){
			$this->response(array('success'=>0));
		}else{
			$this->response(array('success'=>1,'data'=>$data[0]));
		}
	} 

	//response code
	//0 : email error
	//1 : name error
	//2 : unkown

	function facebook_user_register_post(){
		$fb_id=$this->post('fb_id');
		$fullname=$this->post('full_name');
		$email=$this->post('email');

		$this->load->model('users_model');
		$data=$this->users_model->get_by_exact_email($email);
		if($data!=null){
			$this->response(array('success'=>0));
		}

		$data=array(
			'fb_id'=>$fb_id,
			'email'=>$email,
			'full_name'=>$fullname,
			'avt'=> get_facebook_avt($fb_id, 200, 200),
			'perm'=>USER
		);


		$insert_id = $this->users_model->insert($data);
		if($insert_id!=0){
			$data=$this->users_model->get_by_fb_id($fb_id);
			$this->response(array('success'=>2,'data'=>$data[0]));
		}else{
			$this->response(array('success'=>1));
		}
		$this->response(array('success'=>1));
	}

	function check_mail_register_valid_post(){
		$email=$this->post('email');
		$user_name=$this->post('user_name');
		$full_name=$this->post('full_name');
		$pwd=$this->post('pwd');
		//$this->response(array('success'=>0));
		if($email!=null && $user_name!=null){
			//$this->response(array('success'=>0));
			$data=$this->users_model->get_by_exact_email($email);
			if($data!=null){
				//email exist
				$this->response(array('success'=>0));
				//exit();
			}

			$data=$this->users_model->get_by_exact_name($user_name);
			if($data!=null){
				//username exist
				$this->response(array('success'=>1));
				//exit();
			}

			$this->load->helper('ultils');
			$this->load->model('verified_account_model');
			$this->load->helper('email_ultils');
			$code=substr(md5(uniqid(rand(), true)), 6, 6);
			send_verified_mail($code,$email);

			$data['email']=$email;
			$data['user_name']=$user_name;
			$data['code']=$code;
			$data['pwd']=encrypt_pwd($pwd);

			if($this->verified_account_model->get_by_email($email)!=null){
				$this->verified_account_model->update($data,array('email'=>$email));
			}else{
				$this->verified_account_model->insert($data);
			}
			$this->response(array('success'=>3));
		}
		$this->response(array('success'=>0));
		
	}


	function resend_verified_code_post(){
		$email=$this->input->post('email');
		$this->load->model('verified_account_model');
		//if email method
		$data=$this->verified_account_model->get_by_email($email);
		if($data!=null){
			$this->load->helper('email_ultils');
			$code=substr(md5(uniqid(rand(), true)), 6, 6);
			send_verified_mail($code,$email);
			$data=array();
			$data['code']=$code;
			$this->verified_account_model->update($data, array('email'=>$email));
			$this->response(array('success'=>1));
		}
		$this->response(array('success'=>0));
	}

	function register_post() 
	{ 
		$code=$this->post('code');
		$email=$this->post('email');
		if($code==null && $email==null){
			$this->response(array('success'=>'0'));
		}

		$this->load->model('verified_account_model');
		$data=$this->verified_account_model->get_by_email_and_code($email,$code);
		if($data!=null){
			$insert_data['email']=$data[0]->email;
			$insert_data['user_name']=$data[0]->user_name;
			$insert_data['full_name']=$data[0]->full_name;
			$insert_data['address']='';
			$insert_data['pwd']=$data[0]->pwd;
			$insert_data['perm']=2;
			$insert_id = $this->users_model->insert($insert_data);
			if($insert_id!=0){
				$this->verified_account_model->remove(array('email'=>$email));
				$this->response(array('success'=>1,'data'=>$this->users_model->get_by_id($insert_id)));
			}else{
				$this->response(array('success'=>0));
			}
		}else{
			$this->response(array('success'=>0));
		}
	} 


	function update_avt_post(){
		if(isset($_FILES['avt'])){
			$id=$this->input->post('user_id');
			$config['upload_path'] = 'uploads/avts';
			$config['allowed_types'] = 'gif|jpg|png|jpeg|JPG|JPEG|GIF|PNG';
			$config['max_size']	= '15000';
			$this->load->library('upload', $config);
			$filename=$_FILES['avt']['name'];
			$_FILES['avt']['name']=rename_upload_file($filename);	
			if ($this->upload->do_upload('avt'))
			{
				$user=$this->users_model->get_by_id($id);
				if(file_exists($user[0]->avt)){
					unlink($user[0]->avt);
				}
				$image_path='uploads/avts/'.$_FILES['avt']['name'];
				$data=array('avt'=>$image_path);
				$this->users_model->update($data,array('id'=>$id));	
				$obj=$this->users_model->get_by_id($id);
				$this->response(array('success'=>1,'data'=>$obj[0]));
			}else{
				$this->response(array('success'=>0));
			}
		}
	}

	function reset_pwd_post(){
		$type=$this->input->post('type');
		$data=$this->input->post('data');
		
		//send email
		$new_pass=gen_uuid();

		$new_pass=encrypt_pwd($new_pass);
		$this->users_model->update(array('pwd'=>$new_pass),array('email'=>$data));
	}

	function user_put() 
	{ 
		$data = array('this not available'); 
		$this->response($data); 
	} 

	function user_delete() 
	{ 
		$data = array('this not available');
		$this->response($data); 
	} 

	function check_user_active_post(){
		$id=$this->input->post('id');
		$data=$this->users_model->get_by_id($id);
		if($data==null){
			$this->response(array('success'=>0));
		}else{
			$data=$data[0];
			if($data->activated==0){
				$this->response(array('success'=>0));
			}else{
				$this->response(array('success'=>1));
			}
		}
	} 

	function unlock_ads_post(){
		$id=$this->input->post('id');
		$this->users_model->update(array('is_ads'=>1),array('id'=>$id));
		$data=$this->users_model->get_by_id($id);
		$data=$data[0];
		$this->response(array('data'=>$data));
	}

	function pro_date_post(){
		$id=$this->input->post('id');
		$type=$this->input->post('type');
		$data=$this->users_model->get_by_id($id);
		$data=$data[0];
		$type=(int)$type;
		switch ($type) {
			case 1:
			$update = date('Y-m-d',strtotime($data->pro_date. "+ 1 month"));
			$this->users_model->update(array('pro_date'=>$update),array('id'=>$id));
			break;
			
			case 2:
			$update = date('Y-m-d',strtotime($data->pro_date. "+ 3 months"));
			$this->users_model->update(array('pro_date'=>$update),array('id'=>$id));
			break;

			case 3:
			$update = date('Y-m-d',strtotime($data->pro_date. "+ 1 year"));
			$this->users_model->update(array('pro_date'=>$update),array('id'=>$id));
			break;
		}
		$data=$this->users_model->get_by_id($id);
		$data=$data[0];
		$this->response(array('data'=>$data));
	}

}
?>